my_data <- list(
    # Server configuration
    "host" = "localhost",  # default host
    "port" = 8080,
    # Enable debug mode
    "debug" = TRUE
)
my_data <- list(
    # Server configuration
    "host" = "localhost",  # default host
    "port" = 8080,
    # Enable debug mode
    "debug" = TRUE
)

my_data = Dict(
    "users" => [Dict("name" => "Bob", "tags" => ["admin", "user"]), Dict("name" => "Carol", "tags" => ["guest"])],
)
my_data = Dict(
    "users" => [Dict("name" => "Bob", "tags" => ["admin", "user"]), Dict("name" => "Carol", "tags" => ["guest"])],
)

module fval_m
  implicit none
  type :: fval_t
    integer :: t = 0
  end type fval_t
contains
  function fnull() result(v); type(fval_t) :: v; end function
  function fbool(b) result(v); logical, intent(in) :: b; type(fval_t) :: v; end function
  function fint(n) result(v); integer, intent(in) :: n; type(fval_t) :: v; end function
  function freal(x) result(v); real, intent(in) :: x; type(fval_t) :: v; end function
  function fstr(s) result(v); character(len=*), intent(in) :: s; type(fval_t) :: v; end function
  function flist(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fmap(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fset(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fentry(k, u) result(v); character(len=*), intent(in) :: k; type(fval_t), intent(in) :: u; type(fval_t) :: v; end function
end module fval_m
program check
  use fval_m
  implicit none
  type(fval_t) :: my_data
  my_data = flist([fval_t :: &
      fbool(.true.), &
      fstr('hi'), &
      flist([fval_t :: fint(1), fint(2)]), &
      fnull() &
  ])
end program check

my_data = [
    Dict("first" => "Alice", "last" => "Smith"),
    Dict("first" => "Bob", "last" => "Jones"),
]
my_data = [
    Dict("first" => "Alice", "last" => "Smith"),
    Dict("first" => "Bob", "last" => "Jones"),
]

Dict(
    "level1" => Dict("level2" => Dict("level3" => Dict("level4" => Dict("value" => "deep", "items" => ["a", "b"])), "sibling" => 42), "tags" => [Dict("name" => "tag1", "meta" => Dict("priority" => 1, "labels" => ["x", "y"]))]),
)

my_data <- list(
    list("first" = "Alice", "last" = "Smith"),
    list("first" = "Bob", "last" = "Jones")
)
my_data <- list(
    list("first" = "Alice", "last" = "Smith"),
    list("first" = "Bob", "last" = "Jones")
)

my_data <- list(
    "key\nwith\nnewlines" = "value1",
    "key\twith\ttabs" = "value2",
    "value3"
)
my_data <- list(
    "key\nwith\nnewlines" = "value1",
    "key\twith\ttabs" = "value2",
    "value3"
)

x <- list(
    "level1" = list("level2" = list("level3" = list("level4" = list("value" = "deep", "items" = list("a", "b"))), "sibling" = 42), "tags" = list(list("name" = "tag1", "meta" = list("priority" = 1, "labels" = list("x", "y")))))
)

my_data = [
    [Dict("name" => "Alice"), Dict("name" => "Bob")],
    [Dict("name" => "Charlie"), Dict("name" => "Dave")],
]
my_data = [
    [Dict("name" => "Alice"), Dict("name" => "Bob")],
    [Dict("name" => "Charlie"), Dict("name" => "Dave")],
]

my_data <- list(
    list("type" = "create", "pr_id" = "pr_1", "draft" = TRUE),
    list("type" = "create", "pr_id" = "pr_2")
)
my_data <- list(
    list("type" = "create", "pr_id" = "pr_1", "draft" = TRUE),
    list("type" = "create", "pr_id" = "pr_2")
)

my_data = [
    Dict("type" => "create", "pr_id" => "pr_1", "draft" => true),
    Dict("type" => "create", "pr_id" => "pr_2"),
]
my_data = [
    Dict("type" => "create", "pr_id" => "pr_1", "draft" => true),
    Dict("type" => "create", "pr_id" => "pr_2"),
]

my_data = Dict(
    "name" => "Alice",
    "age" => 30,
    "active" => true,
    "score" => nothing,
)
my_data = Dict(
    "name" => "Alice",
    "age" => 30,
    "active" => true,
    "score" => nothing,
)

my_data <- list(
    "users" = list(list("name" = "Bob", "tags" = list("admin", "user")), list("name" = "Carol", "tags" = list("guest")))
)
my_data <- list(
    "users" = list(list("name" = "Bob", "tags" = list("admin", "user")), list("name" = "Carol", "tags" = list("guest")))
)

my_data <- list(
    list(list("name" = "Alice"), list("name" = "Bob")),
    list(list("name" = "Charlie"), list("name" = "Dave"))
)
my_data <- list(
    list(list("name" = "Alice"), list("name" = "Bob")),
    list(list("name" = "Charlie"), list("name" = "Dave"))
)

my_data = Dict(
    # Server configuration
    "host" => "localhost",  # default host
    "port" => 8080,
    # Enable debug mode
    "debug" => true,
)
my_data = Dict(
    # Server configuration
    "host" => "localhost",  # default host
    "port" => 8080,
    # Enable debug mode
    "debug" => true,
)

using Dates
Dict(
    "name" => "Alice",
    "age" => 30,
    "active" => true,
    "score" => nothing,
    "joined" => Date(2024, 1, 15),
    "last_login" => DateTime(2024, 1, 15, 12, 30, 0),
    "avatar" => "48656c6c6f",
)

module fval_m
  implicit none
  type :: fval_t
    integer :: t = 0
  end type fval_t
contains
  function fnull() result(v); type(fval_t) :: v; end function
  function fbool(b) result(v); logical, intent(in) :: b; type(fval_t) :: v; end function
  function fint(n) result(v); integer, intent(in) :: n; type(fval_t) :: v; end function
  function freal(x) result(v); real, intent(in) :: x; type(fval_t) :: v; end function
  function fstr(s) result(v); character(len=*), intent(in) :: s; type(fval_t) :: v; end function
  function flist(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fmap(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fset(a) result(v); type(fval_t), intent(in) :: a(:); type(fval_t) :: v; end function
  function fentry(k, u) result(v); character(len=*), intent(in) :: k; type(fval_t), intent(in) :: u; type(fval_t) :: v; end function
end module fval_m
subroutine check_declaration()
  use fval_m
  implicit none
  type(fval_t) :: my_data
  my_data = flist([fval_t :: &
      fmap([fval_t :: fentry('name', fstr('Alice')), fentry('age', fint(30))]), &
      fmap([fval_t :: fentry('name', fstr('Bob')), fentry('age', fint(25))]) &
  ])
end subroutine check_declaration

subroutine check_assignment()
  use fval_m
  implicit none
  type(fval_t) :: my_data
  my_data = flist([fval_t :: &
      fmap([fval_t :: fentry('name', fstr('Alice')), fentry('age', fint(30))]), &
      fmap([fval_t :: fentry('name', fstr('Bob')), fentry('age', fint(25))]) &
  ])
end subroutine check_assignment

program main
  call check_declaration()
  call check_assignment()
end program main

$my_data = @(
    "C:\path\to\file";
    "back\\slash";
    "hello \`"world\`"";
    "path\to `"# file";
    "trailing\";
    "both `"quotes''' here";
    "line1\nline2`nwith newline"
)
$my_data = @(
    "C:\path\to\file";
    "back\\slash";
    "hello \`"world\`"";
    "path\to `"# file";
    "trailing\";
    "both `"quotes''' here";
    "line1\nline2`nwith newline"
)

declare -A my_data=(
    ["key\nwith\nnewlines"]="value1"
    ["key\twith\ttabs"]="value2"
    [""]="value3"
)
my_data=(
    ["key\nwith\nnewlines"]="value1"
    ["key\twith\ttabs"]="value2"
    [""]="value3"
)

declare -A my_data=(
    # Server configuration
    ["host"]="localhost"  # default host
    ["port"]=8080
    # Enable debug mode
    ["debug"]=true
)
my_data=(
    # Server configuration
    ["host"]="localhost"  # default host
    ["port"]=8080
    # Enable debug mode
    ["debug"]=true
)

$my_data = @(
    @{"first" = "Alice"; "last" = "Smith"};
    @{"first" = "Bob"; "last" = "Jones"}
)
$my_data = @(
    @{"first" = "Alice"; "last" = "Smith"};
    @{"first" = "Bob"; "last" = "Jones"}
)

$my_data = @{
    "key`nwith`nnewlines" = "value1";
    "key`twith`ttabs" = "value2";
    "" = "value3"
}
$my_data = @{
    "key`nwith`nnewlines" = "value1";
    "key`twith`ttabs" = "value2";
    "" = "value3"
}

$my_data = @{
    # Server configuration
    "host" = "localhost";  # default host
    "port" = 8080;
    # Enable debug mode
    "debug" = $true
}
$my_data = @{
    # Server configuration
    "host" = "localhost";  # default host
    "port" = 8080;
    # Enable debug mode
    "debug" = $true
}

$my_data = @(
    @{"type" = "create"; "pr_id" = "pr_1"; "draft" = $true};
    @{"type" = "create"; "pr_id" = "pr_2"}
)
$my_data = @(
    @{"type" = "create"; "pr_id" = "pr_1"; "draft" = $true};
    @{"type" = "create"; "pr_id" = "pr_2"}
)
